package net.t2code.t2codelib.SPIGOT.system;

import lombok.Getter;
import net.kyori.adventure.platform.bukkit.BukkitAudiences;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.permission.Permission;
import net.t2code.t2codelib.SPIGOT.api.bungeePlayers.T2CbungeePlayers;
import net.t2code.t2codelib.SPIGOT.api.items.T2CitemVersion;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CnmsEnum;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CnmsVersions;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2CpluginCheck;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import net.t2code.t2codelib.SPIGOT.system.bstats.Metrics;
import net.t2code.t2codelib.SPIGOT.system.cmd.CmdExecuter;
import net.t2code.t2codelib.SPIGOT.system.cmd.Development;
import net.t2code.t2codelib.SPIGOT.system.cmd.ReportLogStorage;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import net.t2code.t2codelib.SPIGOT.system.config.languages.LanguagesCreate;
import net.t2code.t2codelib.SPIGOT.system.config.languages.SelectLibMsg;
import net.t2code.t2codelib.T2CplatformDetector;
import net.t2code.t2codelib.Util;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginLogger;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.util.List;
import java.util.logging.Logger;

public final class T2CodeLibMain extends JavaPlugin {
    private static T2CodeLibMain plugin;
    private static Economy eco = null;
    private static Permission perm = null;

    private static List<String> autor;
    private static String version;

    @Getter
    private static Boolean mmIsLoad = true;
    private static Boolean load = false;
    @Getter
    private static T2CplatformDetector.PlatformType plattform;

  //  public static Logger logger;

    @Override
    public void onEnable() {
        // Plugin startup logic
        plugin = this;
        autor = plugin.getDescription().getAuthors();
      //  logger = getLogger();
        version = plugin.getDescription().getVersion();

        try {
            adventure = BukkitAudiences.create(this);
        } catch (Exception e) {
            mmIsLoad = false;
        }
        plattform = T2CplatformDetector.detectPlatform();
        long long_ = T2Ctemplate.onLoadHeader(Util.getPrefix(), autor, version, Util.getSpigot(), Util.getDiscord(), null, null);

        checkIsBungee();
        String prefix = Util.getPrefix();

        try {
            Vault.loadVault();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        T2CmcVersion.onCheck();

        if (T2CnmsVersions.getT2CnmsEnum() == T2CnmsEnum.not_support) {
            T2Ctemplate.onStartMsg(prefix, "§4!!!!!!!!!!!!!!!!!!!!");
            T2Ctemplate.onStartMsg(prefix, "");
            T2Csend.warning(plugin, "The " + T2CmcVersion.getMcVersion() + " is a very fresh / new version.");
            T2Csend.warning(plugin, "The plugin may not yet be supported on this server! If there are any bugs in our plugins, please report them to us via our Discord: http://dc.t2code.net");
            T2Ctemplate.onStartMsg(prefix, "");
            T2Ctemplate.onStartMsg(prefix, "§4!!!!!!!!!!!!!!!!!!!!");
            try {
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }
        if (T2CmcVersion.isMc1_21()) {
            T2Ctemplate.onStartMsg(prefix, "§4!!!!!!!!!!!!!!!!!!!!");
            T2Ctemplate.onStartMsg(prefix, "");
            T2Csend.warning(plugin, "The 1.21 is a very fresh / new version. If there are any bugs in our plugins, please report them to us via our Discord: http://dc.t2code.net");
            T2Ctemplate.onStartMsg(prefix, "");
            T2Ctemplate.onStartMsg(prefix, "§4!!!!!!!!!!!!!!!!!!!!");
            try {
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        T2Ctemplate.onLoadSeparateStroke(prefix);
        T2Ctemplate.onStartMsg(prefix, "§2Server run on:");
        T2Ctemplate.onStartMsg(prefix, "§3Platform: §6" + plattform.name());
        T2Ctemplate.onStartMsg(prefix, "§3mcVersion: §6" + T2CmcVersion.getMcVersion());
        T2Ctemplate.onStartMsg(prefix, "§3bukkitVersion: §6" + T2CmcVersion.getBukkitVersion());
        T2Ctemplate.onStartMsg(prefix, "§3nms: §6" + T2CmcVersion.getNms());
        T2Ctemplate.onLoadSeparateStroke(prefix);
        if (eco != null) {
            String st = eco.getName();
            if (eco.getName().equals("CMIEconomy")) st = "CMI";
            if (Bukkit.getPluginManager().getPlugin(st) != null) {
                T2Ctemplate.onStartMsg(prefix, "§3Economy: §6" + eco.getName() + " - " + Bukkit.getPluginManager().getPlugin(st).getDescription().getVersion() + " §7- §e" +
                        (System.currentTimeMillis() - long_) + "ms");
            } else
                T2Ctemplate.onStartMsg(prefix, "§3Economy: §6" + eco.getName() + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
        } else
            T2Ctemplate.onStartMsg(prefix, "§3Economy: §4not connected via vault!" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");

        if (perm != null) {
            if (Bukkit.getPluginManager().getPlugin(perm.getName()) != null) {
                T2Ctemplate.onStartMsg(prefix, "§3Permission plugin: §6" + perm.getName() + " - " + Bukkit.getPluginManager().getPlugin(perm.getName()).getDescription().getVersion()
                        + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
            } else
                T2Ctemplate.onStartMsg(prefix, "§3Permission plugin: §6" + perm.getName() + " - §7- §e" + (System.currentTimeMillis() - long_) + "ms");
        } else
            T2Ctemplate.onStartMsg(prefix, "§3Permission plugin: §4not connected via vault!" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");

        if (T2CpluginCheck.papi()) {
            T2Ctemplate.onStartMsg(prefix, "§3PlaceholderAPI: §6connected" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
        }

        T2Ctemplate.onStartMsg(prefix, "§3Kyori MiniMessage Support: " + (getMmIsLoad() ? "§2load" : "§4not load") + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");


        plugin.getCommand("t2code").setExecutor(new CmdExecuter());
        T2CLibConfig.set();
        T2Ctemplate.onLoadSeparateStroke(prefix);
        T2Ctemplate.onStartMsg(prefix, "§3Use Proxy: §6" + (boolean)T2CLibConfig.VALUES.proxy.getValue());
        T2Ctemplate.onStartMsg(prefix, "§3serverUUID: §6" + T2CLibConfig.VALUES.serverUUID.getValue());
        T2Ctemplate.onLoadSeparateStroke(prefix);
        T2CitemVersion.scan();
        LanguagesCreate.langCreate();
        SelectLibMsg.onSelect();

        T2CupdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), Util.getSpigotID(), Util.getDiscord(),
                (boolean) T2CLibConfig.VALUES.updateCheckOnJoin.getValue(),
                (boolean) T2CLibConfig.VALUES.seePreReleaseUpdates.getValue(),
                (int) T2CLibConfig.VALUES.updateCheckTimeInterval.getValue());
        Metrics.Bstats(plugin, Util.getBstatsID());
        if ((boolean) T2CLibConfig.VALUES.proxy.getValue()) {
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2c:bcmd");
            T2Csend.debug(plugin, "registerIncomingPluginChannel §et2c:bcmd");

            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2c:bonlp");
            if (!Bukkit.getMessenger().isIncomingChannelRegistered(plugin, "t2c:bonlp")) {
                T2Csend.debug(plugin, "registerIncomingPluginChannel §et2c:bonlp");
                Bukkit.getMessenger().registerIncomingPluginChannel(plugin, "t2c:bonlp", new T2CbungeePlayers());
                T2CbungeePlayers.callAllBungeePlayers();
            }
        }

        ReportLogStorage.load();
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvent(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Development(), plugin);
        T2Ctemplate.onLoadFooter(prefix, long_);
        load = true;
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
        if (!load) return;
        ReportLogStorage.save();
        if ((boolean) T2CLibConfig.VALUES.inventoriesCloseByServerStop.getValue()) {
            for (Player player : Bukkit.getOnlinePlayers()) {
                player.closeInventory();
            }
        }

        Vault.vaultDisable();
        T2Ctemplate.onDisable(Util.getPrefix(), this);
        if (mmIsLoad) {
            if (this.adventure != null) {
                this.adventure.close();
                this.adventure = null;
            }
        }
    }

    public static File getPath() {
        return plugin.getDataFolder();
    }

    static void setEco(Economy eco) {
        T2CodeLibMain.eco = eco;
    }

    static void setPerm(Permission perm) {
        T2CodeLibMain.perm = perm;
    }

    public static T2CodeLibMain getPlugin() {
        return plugin;
    }

    public static Economy getEco() {
        return eco;
    }

    public static Permission getPerm() {
        return perm;
    }

    public static List<String> getAutor() {
        return autor;
    }

    public static String getVersion() {
        return version;
    }

    private static BukkitAudiences adventure;

    public BukkitAudiences getAdventure() {
        if (adventure == null) {
            throw new IllegalStateException("Tried to access Adventure when the plugin was disabled!");
        }
        return adventure;
    }

    private static void checkIsBungee() {
        File config = new File("spigot.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        isBungee = yamlConfiguration.getBoolean("settings.bungeecord");
    }

    private static Boolean isBungee;

    public static Boolean getIsBungee() {
        return isBungee;
    }

    public static Boolean getMmIsLoad() {
        return mmIsLoad;
    }
}
