package net.t2code.t2codelib;

import lombok.Getter;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

public class Util {

    //@Getter
   // private static final UUID serverUUID = UUID.randomUUID();


    public static String getInfoText() {
        return "<yellow>Description:</yellow> <gold>" + T2CodeLibMain.getPlugin().getDescription().getDescription() + "</gold>";
    }

    public static String getPrefix() {
        return "<dark_gray>[<dark_red>T2Code</dark_red><dark_purple>Lib</dark_purple>]</dark_gray>";
    }
    @Getter
    private static String vPrefix = "[T2CodeLib]";

    public static Integer getSpigotID() {
        return 96388;
    }

    public static String getGit() {
        return "JaTiTV/T2CodeLib";
    }

    public static Integer getBstatsID() {
        return 12518;
    }

    public static String getSpigot() {
        return "https://www.spigotmc.org/resources/" + getSpigotID();
    }

    public static String getDiscord() {
        return "http://dc.t2code.net";
    }

    public static List<String> getT2cPlugins() {
        return Arrays.asList(
                "T2CodeLib",
                "T2C-LuckyBox",
                "WonderBagShop",
                "CommandGUI",
                //   "T2C-OPSecurity",
                "OPSecurity",
                "PaPiTest",
                "T2C-Alias",
                "T2C-AutoResponse",
                "LoreEditor",
                "Booster",
                "AntiMapCopy",
                "AntiCopy",
                "T2C-LoginPermissionAuth"
        );
    }

    @Getter
    private static final String[] configLogo = new String[]{
            "####################################################################################################################",
            "##                                                                                                                ##",
            "##        /$$$$$$$$ /$$$$$$   /$$$$$$                  /$$                                     /$$                ##",
            "##       |__  $$__//$$__  $$ /$$__  $$                | $$                                    | $$                ##",
            "##          | $$  |__/  \\ $$| $$  \\__/  /$$$$$$   /$$$$$$$  /$$$$$$      /$$$$$$$   /$$$$$$  /$$$$$$              ##",
            "##          | $$    /$$$$$$/| $$       /$$__  $$ /$$__  $$ /$$__  $$    | $$__  $$ /$$__  $$|_  $$_/              ##",
            "##          | $$   /$$____/ | $$      | $$  \\ $$| $$  | $$| $$$$$$$$    | $$  \\ $$| $$$$$$$$  | $$                ##",
            "##          | $$  | $$      | $$    $$| $$  | $$| $$  | $$| $$_____/    | $$  | $$| $$_____/  | $$ /$$            ##",
            "##          | $$  | $$$$$$$$|  $$$$$$/|  $$$$$$/|  $$$$$$$|  $$$$$$$ /$$| $$  | $$|  $$$$$$$  |  $$$$/            ##",
            "##          |__/  |________/ \\______/  \\______/  \\_______/ \\_______/|__/|__/  |__/ \\_______/   \\___/              ##",
            "##                                                                                                                ##",
            "##    T2CodeLib from JaTiTV / T2Code.net. In case of problems please contact the Discord: https://dc.t2code.net   ##",
            "##                                                                                                                ##",
            "####################################################################################################################"
    };
    @Getter
    public static String[] loadLogo = new String[]{
            "################################################################################",
            "##                                                                            ##",
            "##   _______   ___     _____               _                             _    ##",
            "##  |__   __| |__ \\   / ____|             | |                           | |   ##",
            "##     | |       ) | | |        ___     __| |   ___       _ __     ___  | |_  ##",
            "##     | |      / /  | |       / _ \\   / _` |  / _ \\     | '_ \\   / _ \\ | __| ##",
            "##     | |     / /_  | |____  | (_) | | (_| | |  __/  _  | | | | |  __/ | |_  ##",
            "##     |_|    |____|  \\_____|  \\___/   \\__,_|  \\___| (_) |_| |_|  \\___|  \\__| ##",
            "##                                                                            ##",
            "##                    T2CodeLib from JaTiTV / T2Code.net.                     ##",
            "##    In case of problems please contact the Discord: https://dc.t2code.net   ##",
            "##                                                                            ##",
            "################################################################################"
    };
}
