// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.commands;

import com.velocitypowered.api.command.CommandManager;
import com.velocitypowered.api.command.CommandSource;
import com.velocitypowered.api.proxy.ConsoleCommandSource;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.slf4j.Logger;

public class T2CVcmd {

    private static final ProxyServer server = T2CodeVMain.getServer();
    private static final Logger logger = T2CodeVMain.getLogger();

    public static void Console(String cmd) {
        // Get the console command source
        ConsoleCommandSource console = server.getConsoleCommandSource();

        // Dispatch the command
        server.getCommandManager().executeAsync(console, cmd).join();
    }

    public static void Player(CommandSource player, String cmd) {
        CommandManager commandManager = server.getCommandManager();

        // Dispatch the command
        commandManager.executeImmediatelyAsync(player, cmd);
    }

}